// 004 u_c_bombed_maze_factory_1
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_bombed_maze_factory_1;
  interface
    uses u_c_maze_1, u_c_bombed_room_and_wall_1
        , u_c_maze_factory_1;

    type c_bombed_maze_factory= class(c_maze_factory)
                                     Constructor create_bombed_maze_factory;

                                     function f_c_create_room(p_room_number: Integer): c_room; Override;
                                     function f_c_create_wall: c_wall; Override;
                                   end; // c_bombed_maze_factory



  implementation

    // -- c_bombed_maze_factory

    Constructor c_bombed_maze_factory.create_bombed_maze_factory;
      begin
        Inherited create_maze_factory;
      end; // create_bombed_maze_factory

    function c_bombed_maze_factory.f_c_create_room(p_room_number: Integer): c_room;
      begin
        Result:= c_bombed_room.create_bombed_room(p_room_number);
      end; // f_c_create_room

    function c_bombed_maze_factory.f_c_create_wall: c_wall;
      begin
        Result:= c_bombed_wall.create_bombed_wall;
      end; // f_c_create_door

    begin // u_c_maze_factory
    end. // u_c_maze_factory


