// 002 u_c_maze_game_1
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

// -- building the maze with hard-coded construction

unit u_c_maze_game_1;
  interface
    uses u_c_maze_1;

    type c_maze_game= Class
                        constructor create_maze_game;
                        function f_c_create_maze: c_maze;
                      end; // c_maze_game

  implementation
    uses SysUtils, u_c_display;

    // -- c_maze_game

    constructor c_maze_game.create_maze_game;
      begin
        Inherited Create;
      end; // create_maze_game

    function c_maze_game.f_c_create_maze: c_maze;
      var l_c_room_1: c_room;
          l_c_room_2: c_room;
          l_c_door: c_door;
      begin
        Result:= c_maze.create_maze;
        l_c_room_1:= c_room.create_room(1);
        l_c_room_2:= c_room.create_room(2);
        l_c_door:= c_door.create_door(l_c_room_1, l_c_room_2);

        Result.add_room(l_c_room_1);
        Result.add_room(l_c_room_2);

        with l_c_room_1 do
        begin
          set_side(e_north, c_wall.create_wall);
          set_side(e_east, l_c_door);
          set_side(e_south, c_wall.create_wall);
          set_side(e_west, c_wall.create_wall);
        end;

        with l_c_room_2 do
        begin
          set_side(e_north, c_wall.create_wall);
          set_side(e_east, c_wall.create_wall);
          set_side(e_south, c_wall.create_wall);
          set_side(e_west, l_c_door);
        end;
      end; // f_c_create_maze
         
  end. // u_c_maze

